#ifndef PAVELN_H
#define PAVELN_H
#include <assert.h> 

class PavelN : public Strategy {
public:
	int round;
	bool array[110];

  virtual void reset(){
	round = 0;
	srand(time(0));
	for(int i=0;i<110;i++)
		array[i] = false;
  }

  //vrati pocet C soupere z predchozich kol
  int sum(){
	int _sum = 0;
  	for(int i=0;i<round && i<110;i++){
		if(array[i]){
			_sum++;
		}
	}
	return _sum;
  }


  virtual int operator()() { 
    if(round < 25){
	if (DRAND()>0.5) return COOPERATE; else return DECEIVE;
    }else{
        int tmp = sum();
        //ve vice nez 2/3 pripadu souper kooperuje - PODVEDU HO ;]
	if(tmp > round/3 * 2){
		return DECEIVE;
	//souper casto podvadi - tez ho podvedu ;]
	}else if( tmp < round/4 ){
		return DECEIVE;
	//souper v cca polovine pripadu nepodvadi, tez nepodvadim
	}else{
		return COOPERATE;
	}
	
    }

  } 

  virtual void reward(int _reward){
    // printf("round: %d \n",round);
	if(_reward == CC || _reward == DC){
	  assert( round < 110 );
	  array[round] = true;		
	}else{
	  assert( round < 110 );
	  array[round] = false;		
	}
	round++;
  }

  virtual string getName() { return "Pavel_Nohejl"; }  // pojmenujte si ji  
}; 
#endif
